<?php
require_once ALI_APPLICATION_PATH . '/services/AbstractService.php';

class Ali_Service_Setup extends Ali_Service_AbstractService
{
    public function install()
    {
        $tracking = Ali_Application::getModel('Tracking');

        $this->_query(
            "CREATE TABLE IF NOT EXISTS `{$tracking->prefixTable('keyword')}` (
                `keyword_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                `value` text NOT NULL,
                PRIMARY KEY (`keyword_id`)
            ) ENGINE=InnoDB"
        );

        $this->_query(
            "CREATE TABLE IF NOT EXISTS `{$tracking->prefixTable('url')}` (
                  `url_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                  `value` text NOT NULL,
                  PRIMARY KEY (`url_id`)
            ) ENGINE=InnoDB"
        );

        $this->_query(
            "CREATE TABLE IF NOT EXISTS `{$tracking->prefixTable('visitor')}` (
                  `visitor_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                  `value` binary(13) NOT NULL,
                  PRIMARY KEY (`visitor_id`),
                  KEY `value` (`value`)
            ) ENGINE=InnoDB"
        );

        $this->_query(
            "CREATE TABLE IF NOT EXISTS `{$tracking->prefixTable('click')}` (
                `click_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                `datetime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                `keyword_id` bigint(20) unsigned NOT NULL,
                `url_id` bigint(20) unsigned NOT NULL,
                `visitor_id` bigint(20) unsigned NOT NULL,
                PRIMARY KEY (`click_id`),
                KEY `datetime` (`datetime`),
                KEY `keyword_id` (`keyword_id`),
                KEY `url_id` (`url_id`),
                KEY `visitor_id` (`visitor_id`),
                FOREIGN KEY (`visitor_id`) REFERENCES `{$tracking->prefixTable('visitor')}` (`visitor_id`) ON DELETE CASCADE ON UPDATE CASCADE,
                FOREIGN KEY (`keyword_id`) REFERENCES `{$tracking->prefixTable('keyword')}` (`keyword_id`) ON DELETE CASCADE ON UPDATE CASCADE,
                FOREIGN KEY (`url_id`) REFERENCES `{$tracking->prefixTable('url')}` (`url_id`) ON DELETE CASCADE ON UPDATE CASCADE
            ) ENGINE=InnoDB"
        );
    }

    protected function _query($sql)
    {
        global $wpdb;
        $wpdb->last_error = '';

        $wpdb->query($sql);

        if ('' != $wpdb->last_error) {
            throw new Exception("Database scheme update failed: {$wpdb->last_error} (SQL: {$sql})");
        }
    }
}